//	startcd.narod.ru
// 

#include "bp.h"
#include "pin_macros.h"
#include "one_wire.h"
#include "fan.h"
#include "font.h"
#include "eeprom.h"

#define TEST_PIN		B,0,H
#define	TEST_PIN_SIGN	{DRIVER(TEST_PIN,OUT);ON(TEST_PIN);OFF(TEST_PIN);}

static volatile uint8_t LedTimeSwitch;
uint8_t ChangeLight, TimeFlag, Znakomesto, LightISR, LedBuff[9],
		Key, AntiDrebezg[3];//, inc;
uint8_t State, //  - , .
ViewStr, //  ,    
ShowStr, //   /   (0 Uout  Iout)   
RegimTrig, 
EnableU, 
TAlert;


uint16_t mask, Time_in_Regim;
uint8_t ADCUsr[5+1];//0       
//uint16_t SumADC[5+1];//-            1,     .
uint16_t SumADC[5+1];//-            1,     .
uint16_t AdcValue[5+1];//  .   
uint16_t Uref;
uint16_t Uout, Iout, Ucap, PowerVT, Izadania;

Setting S;

const uint8_t LightDisp[]={55,50,45,35,25,17,14,9,3}; 
const uint8_t LightTimeMig[]={35,32,29,28,26,20,17,15,14};//{10,9,8,8,7,5,4,4,3}

const uint8_t StrU_I[][9]={
{F_U,F_o,F_u,F_t,0,N1,F_o,F_u,F_t},			//0 Uout  Iout
{F_U,F_o,F_u,F_t,0,F_U,F_i,F_n,F_C},		//1 Uout  UinC 
{F_U,F_o,F_u,F_t,0,F_P|sH,F_H,F_A,F_G|sH},	//2 Uout P.HA. 
{F_U,F_o,F_u,F_t,0,0,F_P|sH,F_t,F_r|sH},	//3 Uout  .tr.
{F_t,F_gr,F_P,F_A,0,F_t,F_gr,F_t,F_H},		//4 t PA  t tH  
{0,0,F_C,N0,N0,F_L,F_E,F_P,0},				//5 Cooler
{0,0,N5,F_E,F_t,F_U,F_P,0,0},				//6 Setup
{0,F_L,F_I,F_Ge,F_H,F_t,0,0,0},				//7 LIGHT
{F_E,F_E,F_P,0,F_E,F_r,F_r,F_o,F_r}			//8 EEP Error
};

enum ST {ST_WORK=0, ST_SETUP, ST_GL_FAN, ST_GL_ADC, ST_GL_T, ST_GL_LIGHT,
ST_FAN1,ST_FAN2,ST_FAN3,ST_FAN4,ST_FAN5,ST_FAN6,ST_FAN7,ST_FAN8,
ST_LIGHT, ST_T, ST_T1,
ST_ADC1,ST_ADC2,ST_ADC3,ST_ADC4,ST_ADC5,ST_ADC_KANAL_VIEW,
ST_SHOW_IZADANIA
};


//-------------------------------------
//ISR(BADISR_vect)//, ISR_BLOCK
//{}
//-----------------------------------------
//**************************************
ISR(SIG_OVERFLOW0){
	if (++LedTimeSwitch==LightISR)
		OFF(STORAGE);//    Z    PORTLCD=LedBuff[Znakomesto];
}
//--------------------------------------

static void avr_init(void)
{
	
	DRIVER(TEST_PIN,OUT);
	
	//----------------------------
//	TCCR0B=0x01;
	TCCR0=_BV(CS00);
	TIMSK|=(1<<TOIE0);
	//TIFR|=
	//--------Cooler----------------------
	TCCR1A=(1<<WGM10)|(1<<COM1B1);
	TCCR1B=(1<<WGM12)|(1<<CS10);// //Fast PWM, 8-bit 5
	DRIVER(OUT_1B,OUT);
	//------------------------------
	DRIVER(DATA_595,OUT);
	DRIVER(SHIFT,OUT);
	DRIVER(STORAGE,OUT);
	
	DRIVER(KL_F,PULLUP);
	DRIVER(KL_SET,PULLUP);
	DRIVER(KL_PLUS,PULLUP);
	DRIVER(KL_MINUS,PULLUP);
	
	DRIVER(ON_U,OUT);
	DRIVER(LED_ON_U,OUT);
	
	//---ADC----
	ADCSRA=(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0);// clock/64 125000k time= 8uSek(*13cucles=0,000104 time conversion)
	
	sei();
}

static uint16_t adc_rezult(uint8_t kanal){
//TEST_PIN_SIGN;
	uint16_t rez=0;
	ADMUX=ADMUXSETTING|kanal;
	for(uint8_t i=4 ; i ; i--){
		ADCSRA|=_BV(ADSC);
		while ( !(ADCSRA &_BV(ADIF)) );
		rez+=ADC;
		}
//TEST_PIN_SIGN;	
	return rez/4;
}

/*uint16_t read_adc_usr(uint8_t kanal){
    uint16_t tmp = (SumADC[kanal] + (TCHK_USR_ADC/2)) / TCHK_USR_ADC;//    TCHK_USR_ADC 
    SumADC[kanal] += adc_rezult(kanal) - tmp;
	return tmp;
}*/
static void read_adc_usr(uint8_t kanal){
	SumADC[kanal] += adc_rezult(kanal);
	if (++ADCUsr[kanal]>=S.AdcUsr){
		ADCUsr[kanal]=0;
		AdcValue[kanal]=SumADC[kanal]/S.AdcUsr;
		SumADC[kanal]=0;
		}
}


//----------indikator---------------------
static void change_light_var(void)
{
	if ( TimeFlag & FL_PLUS )
		{
		if (++ChangeLight>=S.LedLight) TimeFlag &= ~FL_PLUS;//    
		}
	else
		{
		if (ChangeLight>1) ChangeLight--; else TimeFlag|= FL_PLUS;//  
		}
}
//**************************************
static uint8_t opred_light_current_num(void)
{
	char l;
	unsigned int a=0x100;
 	
	l=S.LedLight;
	if (mask)
	 	{
		a>>=Znakomesto;
		if ( mask&a ) l=ChangeLight;
		}
		else	
		{
		TimeFlag &= ~FL_PLUS;
		ChangeLight=S.LedLight;
		}
	return l;
}
//*************************************************************
static void data_shift(unsigned char data)
{
//   ,    8 . 
	for(uint8_t i=8; i ; i--){  
		if (data & _BV(7) )  ON(DATA_595);	//   
						else OFF(DATA_595); 
		//asm("nop");
		ON(SHIFT); //  
		data<<=1;
		OFF(SHIFT);
		}	 
}
//*************************************************************
static void num_out(void)
{
	ON(STORAGE);//    Z 
	
	data_shift(LedBuff[Znakomesto]);//       
 	data_shift(~(1<<(Znakomesto)));//  ,      ~(1<<(znmesto)) -     ( 03->0b11110111)
 
	OFF(STORAGE); 
	ON(STORAGE);	// 
	//OFF(STORAGE);	//   

	if (Znakomesto==7){// 7  
		ON(SHIFT);//shift    0   Q6  -Q7`
		asm("nop");
		OFF(SHIFT);
		}											
	if (Znakomesto==8)   data_shift(0);//9 . 
	//       1, 
	//     -Q7 = 0,   . 
	
	OFF(DATA_595);
	OFF(SHIFT);  
}

//**************************************
void skankey (void){
	unsigned char key_lokal=0;
	Key &= KEY_F_MEM|KEY_TRIG;
	if 		( ACTIVE(KL_F) )		key_lokal|=KEY_F;
	else if ( ACTIVE(KL_SET) )		key_lokal|=KEY_SET;
	else if ( ACTIVE(KL_PLUS) )		key_lokal|=KEY_PLUS;
	else if ( ACTIVE(KL_MINUS) )	key_lokal|=KEY_MINUS;

	if ( key_lokal )
	{
	AntiDrebezg[0]++;
		if (AntiDrebezg[0]==35)//   
		{
		Key=key_lokal;//   
		if (AntiDrebezg[1]<=40) AntiDrebezg[1]++;// -     
		//button_signal();
		}
		if (AntiDrebezg[0]==AntiDrebezg[2]){//   	
			AntiDrebezg[0]=0;//     														
			if (  AntiDrebezg[1]==2) AntiDrebezg[2]=120;//55;//      (    )
			if (  AntiDrebezg[1]==4) AntiDrebezg[2]=80;//55;
			if (  AntiDrebezg[1]==6) AntiDrebezg[2]=55;//55;
			if (  AntiDrebezg[1]==8) AntiDrebezg[2]=45;//55;
			if (  AntiDrebezg[1]>=20) AntiDrebezg[2]=35;//55;
			//if (  AntiDrebezg[1]>=40) inc=2;//55;
			}	
	//if (ShowStr) Time_in_Regim=TimReg(1.5);
	if (ShowStr==0) Time_in_Regim=TimReg(25); 
		
	}
	else
	{
	AntiDrebezg[0]=0;//AntiDrebezg[0]  
	AntiDrebezg[1]=0;//AntiDrebezg[1] -   
	AntiDrebezg[2]=200;//AntiDrebezg[2]    
	//inc=1;
	}
 }
//*************************************************************

void itoa2(int16_t Val, uint8_t * Buf)
{
#define BCD_SIZEOF	4
const uint16_t step[]={1000,100,10,1};
//const uint16_t step[]={10000,1000,100,10,1};
int16_t Subtract, Value;
uint8_t i, Dig;

	Value=Val;
	for (i=0; i<BCD_SIZEOF; i++)
	{
	Subtract=step[i];
	Dig=0;
	while(Value >= Subtract)
		{
		Dig++;
		Value-=Subtract;
		}
	Buf[i]=FontNum[Dig];
	}
}

static uint16_t editparam(uint16_t p, uint16_t limit){
uint8_t inc=1;
if (  AntiDrebezg[1]>=40) inc=2;
	if ( Key & KEY_PLUS ){
		if ( p<limit-inc+1 ) p+=inc; else p=0;
		}
	if ( Key & KEY_MINUS ){
		if ( p > (inc-1) ) p-=inc; else p=limit;
		}
	return p;
}

static void editstate_P_M_S_F(uint8_t plus, uint8_t minus, uint8_t F, uint8_t Set){
uint8_t st=State;
	if (Key & KEY_MINUS) st=minus;
	if (Key & KEY_PLUS) st=plus;
	if (Key & KEY_SET) st=F;
	if (Key & KEY_F) st=Set;
	State=st;
}

void key_action(void){

	mask=0x00;
	switch (State)
	{
	case (ST_SHOW_IZADANIA):{
        editstate_P_M_S_F(ST_WORK, ST_WORK, ST_WORK, ST_WORK);//   ST_WORK,      
		}
    case (ST_WORK):
		{

        //ViewStr=editparam(ViewStr,4);
		if (Key & (KEY_PLUS|KEY_MINUS)) {
			ViewStr=editparam(ViewStr,4);
			ShowStr=1;
			Time_in_Regim=TimReg(1.5);
			}
			
		if (Key & KEY_F) {
			Key|=KEY_F_MEM;//    F
			ShowStr=0;
			}
		if (Key & KEY_F_MEM) {//   F
			if ( AntiDrebezg[1]==0 ) {//  , 
				EnableU=!EnableU;//if (EnableU==0) EnableU=1; else EnableU=0;
				Key=0;//    
				break;
				}
			else
			if ( AntiDrebezg[1]>=10 ){//    N , 
				State=ST_SETUP;
				EepromFlag=EEPROM_SAVE;
				Key=0;//    
				break;
				}
			}
		
		if (Key & KEY_SET) {
			Key|=KEY_TRIG;//    SET
			ShowStr=0;
			}
		if (Key & KEY_TRIG){	
			if (RegimTrig==0){//   - 
				RegimTrig|=TRIG_REGIM_ON;//
				//OFF(TRIGER_OFF);
				Key=0;
				}
				else{
				RegimTrig&=~TRIG_REGIM_ON;
				Key=0;
				/*
				if ( AntiDrebezg[1]==0 ) {//  , 
					RegimTrig|=TRIG_SBROS_IMP;
					Key=0;
					}
					else{
					if ( AntiDrebezg[1]>=3 ){//    N , 
						//ON(TRIGER_OFF);
						RegimTrig|=TRIG_EVENT_OFF;
						Key=0;
						}
					}*/
				}
			}
        break;
		}
	//---------Global_menu-------------------
	case (ST_SETUP):{
        if ( AntiDrebezg[1]==0 ) {State=ST_GL_FAN; ShowStr=0;}
        break;
		}
	case (ST_GL_FAN):{
        editstate_P_M_S_F(ST_GL_ADC, ST_GL_LIGHT, ST_FAN1, ST_WORK);
		mask=0xFFFF;
        break;
		}
	case (ST_GL_ADC):{
        editstate_P_M_S_F(ST_GL_T, ST_GL_FAN , ST_ADC1, ST_WORK);
		mask=0xFFFF;
        break;
		}
	case (ST_GL_T):{
        editstate_P_M_S_F(ST_GL_LIGHT, ST_GL_ADC , ST_T, ST_WORK);
		mask=0xFFFF;
        break;
		}
	case (ST_GL_LIGHT):{
        editstate_P_M_S_F(ST_GL_FAN, ST_GL_T , ST_LIGHT, ST_WORK);
		mask=0xFFFF;
        break;
		}
		
		
	//-------------Cooler-----------------
	case (ST_FAN1):{
		//FanState&=~FAN_U_SETUP;
        editstate_P_M_S_F(State,State, ST_FAN2, ST_GL_FAN);
		S.Fan.TLow=editparam(S.Fan.TLow,70);
		mask=_BV(7)|_BV(6);
        break;
		}
	case (ST_FAN2):{
        editstate_P_M_S_F(State,State, ST_FAN3, ST_GL_FAN);
		S.Fan.THi=editparam(S.Fan.THi,99);
		mask=_BV(2)|_BV(1);
        break;
		}
	case (ST_FAN3):{
        editstate_P_M_S_F(State,State, ST_FAN4, ST_GL_FAN);
		S.Fan.ULow=editparam(S.Fan.ULow,0xFF);
		pwm_power_setup(S.Fan.ULow);
		mask=_BV(4)|_BV(6)|_BV(5);
        break;
		}
	case (ST_FAN4):{
        editstate_P_M_S_F(State,State, ST_FAN5, ST_GL_FAN);
		S.Fan.UHi=editparam(S.Fan.UHi,0xFF);
		pwm_power_setup(S.Fan.UHi);
		mask=_BV(2)|_BV(1)|_BV(0);
        break;
		}
	case (ST_FAN5):{
        editstate_P_M_S_F(State,State, ST_FAN6, ST_GL_FAN);
		S.Fan.USpinUp=editparam(S.Fan.USpinUp,0xFF);
		pwm_power_setup(S.Fan.USpinUp);
		mask=_BV(6)|_BV(5)|_BV(4);
        break;
		}
	case (ST_FAN6):{
		//FanState&=~FAN_U_SETUP;
        editstate_P_M_S_F(State,State, ST_FAN7, ST_GL_FAN);
		S.Fan.TimSpinUp=editparam(S.Fan.TimSpinUp,10);
		mask=_BV(2);
        break;
		}
	case (ST_FAN7):{
        editstate_P_M_S_F(State,State, ST_FAN8, ST_GL_FAN);
		S.Fan.OffTLo=editparam(S.Fan.OffTLo,1);
		mask=_BV(0);
        break;
		}
	case (ST_FAN8):{
        editstate_P_M_S_F(State,State, ST_FAN1, ST_GL_FAN);
		S.Fan.OnWhenPowerVt=editparam(S.Fan.OnWhenPowerVt,99);
		mask=_BV(0)|_BV(1);
        break;
		}
	//------------End-Cooler-----------------
	case (ST_LIGHT):{
        editstate_P_M_S_F(State,State, ST_GL_LIGHT, ST_WORK);
		S.LedLight=editparam(S.LedLight,8);
		mask=_BV(1);
        break;
		}	
	case (ST_T):{
        editstate_P_M_S_F(State,State, ST_T1, ST_GL_T);
		S.TemperEvent[T_VT]=editparam(S.TemperEvent[T_VT],99);
		mask=_BV(6)|_BV(5);
        break;
		}
	case (ST_T1):{
        editstate_P_M_S_F(State,State, ST_T, ST_GL_T);
		S.TemperEvent[T_TRANS]=editparam(S.TemperEvent[T_TRANS],99);
		mask=_BV(1)|_BV(0);
        break;
		}	
	case (ST_ADC1):
	case (ST_ADC2):
	case (ST_ADC3):
	case (ST_ADC4):
		{
        editstate_P_M_S_F(State,State, State+1, ST_GL_ADC);
		//if (State==ST_ADC4+1) State=ST_ADC1;
		S.Uref[State-ST_ADC1]=editparam(S.Uref[State-ST_ADC1],9);
		mask=1<<(ST_ADC4-State);
        break;
		}	
	case (ST_ADC5):
		{
        editstate_P_M_S_F(State,State, ST_ADC_KANAL_VIEW, ST_GL_ADC);
		S.AdcUsr=editparam(S.AdcUsr,63);
		mask=_BV(1)|_BV(0);
        break;
		}
	case (ST_ADC_KANAL_VIEW):
		{
        editstate_P_M_S_F(State,State, ST_ADC1, ST_GL_ADC);
		ADCUsr[0]=editparam(ADCUsr[0],4);
		mask=_BV(8)|_BV(7)|_BV(6)|_BV(5);
        break;
		}
	}
	
	if ( AntiDrebezg[1] ) mask=0x00;
}

static uint16_t convert_adc_to_int(uint16_t r){
uint32_t j;
	j=((uint32_t)r*Uref)>>10;
	return (uint16_t)j;
	//return (uint16_t)( ((uint32_t)r*Uref)>>10 );
}

static uint16_t convert_adc_to_int_u(uint16_t r){
uint32_t j;
	j=((uint32_t)r*Uref*KOEF_U)>>10;// /1024
	return (uint16_t)j;
}

static void ds_t(uint8_t i){
uint8_t m[BCD_SIZEOF];
if ( (PinWireDS[i] & Power1w)==0 ){ 
	m[1]=F_n;
	m[2]=F_o;
	m[3]=F_d;
	m[0]=N5;
	}else{
	itoa2(Temperaturs[i], m);
	m[0]=F_gr;
	}
	if (i==T_TRANS) i=5; else i=0;
	LedBuff[i]=m[1];
	LedBuff[i+1]=m[2]|sH;
	LedBuff[i+2]=m[3];
	LedBuff[i+3]=m[0];
}

static uint16_t i_zadania(void){
return	((uint32_t)(convert_adc_to_int(Izadania))*303+55)/400;
}

static void work_led_str(uint8_t View){
//Uout  Iout
//Uout  UinC 
//Uout P.HA.
//Uout  .tr.
//t PA  t tH  
	if (View==4) {
		ds_t(T_VT);
		ds_t(T_TRANS);
		}
		else
		{
		itoa2(Uout, LedBuff);
		LedBuff[1]|=sH;

		if (View==0) {
			itoa2(Iout, &LedBuff[5]);
			LedBuff[5]|=sH;
			}
		else
		if (View==1) {
			itoa2(Ucap, &LedBuff[5]);
			LedBuff[6]|=sH;
			}
		else
		if (View==2) {
			uint16_t P;
			uint8_t h=6;
			P=((uint32_t)Uout*Iout)/1000;
			if (P>=10000){
				P/=10;
				h=7;
				}
			itoa2(P, &LedBuff[5]);
			LedBuff[h]|=sH;
			}
		else
		if (View==3) {
			uint16_t P=PowerVT;
			uint8_t h=6;
			if (P>=10000){
				P/=10;
				h=7;
				}
			itoa2(P, &LedBuff[5]);
			LedBuff[h]|=sH;
			//itoa2(PowerVT, &LedBuff[5]);
			//LedBuff[6]|=sH;
			}
		else
		if (View==10) {
			//itoa2(convert_adc_to_int(Izadania), &LedBuff[5]);
			//itoa2( ((uint32_t)(convert_adc_to_int(Izadania))*303+55)/400, &LedBuff[5]);
			itoa2( i_zadania(), &LedBuff[5]);
			//itoa2( ((uint32_t)convert_adc_to_int(Izadania))*25/33, &LedBuff[5]); //*100/4/33
			LedBuff[4]|=sC;
			LedBuff[5]|=sH;
			}
		}
		if (RegimTrig){
//			if (RegimTrig & TRIG_EVENT_OFF) LedBuff[4]|=F_u;		
			LedBuff[8]|=sH;
			}
		if (!ACTIVE(ON_U)) LedBuff[4]|=sA;
		if (TAlert) LedBuff[4]|=sD|sE|sG;
}

static void load_str(uint8_t j){
	for( uint8_t i=0; i<sizeof(LedBuff) ; i++){
		LedBuff[i]=StrU_I[j][i];
		}
}
static void ledbuff_cls(void){
for(uint8_t j=0; j<sizeof(LedBuff); j++)
	LedBuff[j]=0;
}
//**************************************
void display_data(void){
ledbuff_cls();
switch (State)
	{
	case (ST_WORK):{
		if (EepromFlag){
			load_str(8);
			}
		else
		if (ShowStr){
			load_str(ViewStr);
			}
		else{
			if ( (!ACTIVE(ON_U))&&(Iout==0)&&(ViewStr==0) ) work_led_str(10);
			else work_led_str(ViewStr);
			}
        break;
		}
	case (ST_SETUP):{
        load_str(6);
        break;
		}	
	case (ST_SHOW_IZADANIA):{
        work_led_str(10);
        break;
		}
	case (ST_GL_FAN):{
        load_str(5);
        break;
		}
	case (ST_GL_ADC):{
        LedBuff[4]=F_A;
        LedBuff[5]=F_d;
        LedBuff[6]=F_C;
        break;
		}
	case (ST_GL_T):{
		LedBuff[4]=F_t;
        LedBuff[5]=F_gr;
        LedBuff[6]=F_C;
        break;
		}	
	case (ST_GL_LIGHT):
	case (ST_LIGHT):
		{
        load_str(7);
		LedBuff[7]=FontNum[S.LedLight+1];
        break;
		}
		
	case (ST_FAN1):
	case (ST_FAN2):	
		{
		uint8_t n[BCD_SIZEOF];
		itoa2(S.Fan.TLow,n);
		LedBuff[0]=F_L;
		LedBuff[1]=n[BCD_SIZEOF-2];
		LedBuff[2]=n[BCD_SIZEOF-1];
		LedBuff[3]=F_gr;
		itoa2(S.Fan.THi,&LedBuff[4]);
		LedBuff[4]=0;
		LedBuff[5]=F_H;
		LedBuff[8]=F_gr;
		calculation_step_U();
        break;
		}
	case (ST_FAN3):
	case (ST_FAN4):	
		{
		itoa2(S.Fan.ULow,&LedBuff[1]);
		LedBuff[0]=F_U;
		LedBuff[1]=0;//F_l;
		itoa2(S.Fan.UHi,&LedBuff[5]);
		LedBuff[5]=0;//=F_h;
		calculation_step_U();
        break;
		}
	case (ST_FAN5):
	case (ST_FAN6):	
	case (ST_FAN7):	
		{
		itoa2(S.Fan.USpinUp,&LedBuff[1]);
		LedBuff[0]=F_U;
		LedBuff[1]=F_P;//F_l;
		LedBuff[6]=FontNum[S.Fan.TimSpinUp/2];//=F_h;
		if (S.Fan.TimSpinUp&_BV(0)) LedBuff[6]|=sH;
		LedBuff[7]=F_c;
		if (S.Fan.OffTLo) LedBuff[8]=sG|sF|sB;//F_u;
			else LedBuff[8]=sA|sG;
        break;
		}
	case (ST_FAN8):	
		{
		//uint8_t n[BCD_SIZEOF];
		itoa2(S.Fan.OnWhenPowerVt,&LedBuff[5]);
		LedBuff[0]=N0;
		LedBuff[1]=F_n;
		LedBuff[2]=F_N;
		LedBuff[3]=F_P;//F_l
		LedBuff[4]=F_U;//F_l
		LedBuff[5]=0;//F_l
		LedBuff[6]=F_P;//F_l
		//LedBuff[7]|=sH;//F_l
        break;
		}	
	case (ST_T):
	case (ST_T1):	
		{
		itoa2(S.TemperEvent[T_VT],LedBuff);
		LedBuff[0]=F_P;
		LedBuff[1]=F_A|sH;//F_l;
		itoa2(S.TemperEvent[T_TRANS],&LedBuff[5]);
		LedBuff[5]=F_t;//=F_h;
		LedBuff[6]=F_H|sH;
        break;
		}
	case (ST_ADC1):
	case (ST_ADC2):
	case (ST_ADC3):
	case (ST_ADC4):
		{
        LedBuff[0]=F_U;
        LedBuff[1]=F_r;
        LedBuff[2]=F_E;
        LedBuff[3]=F_F;
		
		LedBuff[5]=FontNum[S.Uref[0]];
		LedBuff[6]=FontNum[S.Uref[1]];
		LedBuff[7]=FontNum[S.Uref[2]];
		LedBuff[8]=FontNum[S.Uref[3]];
        break;
		}
	case (ST_ADC5):
		{
		itoa2(S.AdcUsr,&LedBuff[5]);
		LedBuff[0]=F_U;
        LedBuff[1]=F_C;
        LedBuff[2]=F_P;
        LedBuff[3]=F_E;
        LedBuff[4]=F_d|sH;
		LedBuff[5]=0;
		LedBuff[6]=0;
		break;
		}
	case (ST_ADC_KANAL_VIEW):
		{
		uint8_t s[4];
		switch (ADCUsr[0])
		{
		case 0: 
			s[0]=F_I;
			s[1]=N3;
			s[2]=F_A;
			s[3]=F_d|sH;
			break;
		case 1: 
			s[0]=F_I;
			s[1]=F_o;
			s[2]=F_u;
			s[3]=F_t;
			break;	
		case 2: 
			s[0]=F_U;
			s[1]=F_o;
			s[2]=F_u;
			s[3]=F_t;
			break;
		case 3: 
			s[0]=F_U;
			s[1]=F_r;
			s[2]=N0|sH;
			s[3]=N1;
			break;	
		case 4: 
			s[0]=F_U|sH;
			s[1]=F_H;
			s[2]=F_A|sH;
			s[3]=F_C;
			break;	
		}
		
		for (uint8_t i=0; i<4; i++) LedBuff[i]=s[i];
        itoa2(AdcValue[ADCUsr[0]+1],&LedBuff[5]);
		break;
		}
	}
}



void uref_init(void){
Uref=(uint16_t)S.Uref[0]*1000+(uint16_t)S.Uref[1]*100+S.Uref[2]*10+S.Uref[3];
}

int main(void)
{
uint8_t adc_t=0, TimeMig=0, FanU=0;

    avr_init();
	ds18b20_init();
	eeprom_read();
	uref_init();
	FanState = FAN_POWER_OFF;
	
    while(1)
    {
	if (LedTimeSwitch>=58){/* 2msek*/
	  	ON(STORAGE);//. 
		//TEST_PIN_SIGN;
	
		++Znakomesto;
		LedTimeSwitch=0x00;
		LightISR=LightDisp[opred_light_current_num()];// 
			if (LightISR<4) OFF(STORAGE);//. 
		num_out();//    ,   
		skankey();
		key_action();
		if  (Znakomesto<8) {
				//read_ADC
				//TEST_PIN_SIGN;
				if (++adc_t & _BV(0)){
					read_adc_usr(ADC_U_OUT);//AdcValue[ADC_U_OUT]=read_adc_usr(ADC_U_OUT);
					read_adc_usr(ADC_U_RGND);//AdcValue[ADC_U_RGND]=read_adc_usr(ADC_U_RGND);
					read_adc_usr(ADC_I_OUT);//AdcValue[ADC_I_OUT]=read_adc_usr(ADC_I_OUT);
					}
					else{
					read_adc_usr(ADC_U_CAPACITORS);//AdcValue[ADC_U_CAPACITORS]=read_adc_usr(ADC_U_CAPACITORS);
					read_adc_usr(ADC_I_ZADANIA);//AdcValue[ADC_I_ZADANIA]=read_adc_usr(ADC_I_ZADANIA);
					}
				//TEST_PIN_SIGN;
			}else{
				TEST_PIN_SIGN;// ,   .. 
				uint16_t U;
				U=convert_adc_to_int_u(AdcValue[ADC_U_OUT]);
				//Uout=((U-convert_adc_to_int(AdcValue[ADC_U_RGND]))+5)/10;//   ,  ADC_U_RGND     U
				{uint16_t Ur=convert_adc_to_int(AdcValue[ADC_U_RGND]);
				if (U>Ur) Uout=( (U-Ur)+5 )/10; else Uout=0;}
				Iout=convert_adc_to_int(AdcValue[ADC_I_OUT]);
				Ucap=convert_adc_to_int(AdcValue[ADC_U_CAPACITORS]);
				PowerVT=( ((uint32_t)Ucap-(U+5)/10)*Iout)/1000;
				#define TOLERANCE	2
				if (AdcValue[ADC_I_ZADANIA]>=TOLERANCE)
				if (( Izadania >= AdcValue[ADC_I_ZADANIA]+TOLERANCE) ||
					( Izadania <= AdcValue[ADC_I_ZADANIA]-TOLERANCE)){
					if ((State==ST_WORK)||(State==ST_SHOW_IZADANIA))//        . . Izadania 
						{//(State==ST_SHOW_IZADANIA) ,     .     . ,     3 .
						Time_in_Regim=TimReg(3);
						State=ST_SHOW_IZADANIA;
						}
					}
				Izadania = AdcValue[ADC_I_ZADANIA];
				
				display_data();
				Znakomesto=0xFF;
				//   
				if (izmerenie_t()){
					if ( PowerVT/100 >= S.Fan.OnWhenPowerVt ) 
						FanU=S.Fan.UHi;
						else{ 
						if ( (PowerVT)/100+1 < S.Fan.OnWhenPowerVt ) 
							FanU=0;
						}
					if (( PinWireDS[T_VT] & Power1w )==0) {
						FanU=S.Fan.UHi;
						}
					FAN1_OCR=control_fan(FanU);//    
					
					if (Temperaturs[T_VT] >= S.TemperEvent[T_VT]*10 ) TAlert|=_BV(T_VT);	
					if (Temperaturs[T_TRANS] >= S.TemperEvent[T_TRANS]*10 ) TAlert|=_BV(T_TRANS);
					if ((S.TemperEvent[T_VT]-1)*10  >= Temperaturs[T_VT]) TAlert&=~_BV(T_VT);
					if ((S.TemperEvent[T_TRANS]-1)*10 >= Temperaturs[T_TRANS]) TAlert&=~_BV(T_TRANS);
					}

				//       
				if ((State==ST_WORK)&&(EepromFlag==EEPROM_SAVE)) {
					eeprom_save();
					uref_init();
					FanState&=~FAN_U_SETUP;
					}
				TEST_PIN_SIGN;	
			}
		//------------------
		if (RegimTrig & TRIG_REGIM_ON) {
			if (Iout >= i_zadania()-7 ){// I-7mA
				EnableU=0;
				OFF(ON_U);
				}
			}
		if (Ucap < 1200){
			EnableU=0;
			OFF(ON_U);
			}
		//------------------
		//---- ~1.8ms-----
		if (TAlert) //     
			OFF(ON_U);// 
			else{	
			if (EnableU) ON(ON_U); else OFF(ON_U); //   
			}
		if (LATCH(ON_U)) ON(LED_ON_U); else OFF(LED_ON_U); //    . 
		if (++TimeMig>=LightTimeMig[S.LedLight])//     
			{
			TimeMig=0;
			change_light_var();
			}
		if (--Time_in_Regim==0){//     ST_WORK
			State=ST_WORK;
			ShowStr=0;
			}
		if (FanState & FAN_EVENT_POWER_ON)//  
			{
			if ( --TimeSpinUp<0 ) 	
				{
				FanState&= ~FAN_EVENT_POWER_ON;
				FAN1_OCR=control_fan(FanU);
				}
			}
		}
	}
}
