#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms 262.14ms/F_CPU in MHz; _delay_us 768us/F_CPU in MHz */

#define TimReg(t)	((uint16_t)(t/0.00185))

//DS18B20
#define T_VT		0
#define T_TRANS		1

//------------------------------
#define KL_F		D,4,L 
#define KL_SET		D,3,L 
#define KL_PLUS		D,2,L 
#define KL_MINUS	D,1,L 
//------------------------------------
#define KEY_PLUS	_BV(2)
#define KEY_MINUS	_BV(3)
#define KEY_SET		_BV(1)
#define KEY_F		_BV(0)
//#define KEY_PRESS	_BV(5)
#define KEY_F_MEM	_BV(6)
#define KEY_TRIG	_BV(7)

//---------------74HC595--------------
#define DATA_595	B,4,H
#define SHIFT		B,3,H
#define STORAGE		B,5,H

//------------------------------
#define ON_U		D,0,H
#define LED_ON_U	C,0,H

//-------- TimeFlag  -------
#define	FL_PLUS					_BV(0)//  

//------------ADC----------------
//#define TCHK_USR_ADC	8// 
#define USR_ADC	32// 

#define	ADMUXSETTING	((0<<REFS1)|(1<<REFS0))
#define	ADC_U_OUT			3
#define	ADC_U_CAPACITORS	5
#define	ADC_U_RGND			4
#define	ADC_I_OUT			2
#define	ADC_I_ZADANIA		1
#define	KOEF_U				6//.      
//-----------RegimTrig------------
#define	TRIG_REGIM_ON	_BV(0)
//#define	TRIG_SBROS_IMP	_BV(1)
//#define	TRIG_EVENT_OFF	_BV(2)


typedef struct {
	int8_t TLow;
	int8_t THi;
	uint8_t OnWhenPowerVt;
	uint8_t ULow;
	uint8_t UHi;
	uint16_t Step;
	uint8_t TimSpinUp;
	uint8_t USpinUp;
	uint8_t OffTLo;
	} FanParam;
	
	
typedef struct {
	FanParam Fan;
	uint8_t TemperEvent[2];
	uint8_t LedLight;
	uint8_t Uref[4];
	uint8_t AdcUsr;
	uint16_t Crc;
	}Setting;
	
extern Setting S;
