#include "eeprom.h"
#include "bp.h"

uint8_t EepromFlag;
//-----------------------------EEPROM---------------------------------------
static unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));//     EEPE
	EEAR = uiAddress;//    
	EECR |= (1<<EERE);//       EERE 
	return EEDR;//      
}
static void EEPROM_write(unsigned char uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEWE));//     EEPE
		EEAR = uiAddress;
		EEDR = ucData;
		cli();
		EECR |= (1<<EEMWE);//EEMPE
		EECR |= (1<<EEWE);//EEPE
		sei();
		}
}
void eeprom_save(void){
uint8_t *p, i, a;
	p=(uint8_t *)&S;
	S.Crc=0;
	for(i=0, a=EEPROM_ADR; i<sizeof(S); i++, a++, p++){
		if ( i<sizeof(S)-2) S.Crc+=*p;
		EEPROM_write(a,*p);
		}
	EepromFlag=0;
}

void eeprom_read(void){
uint8_t *p, i, a;
uint16_t crc=0;
	p=(uint8_t *)&S;
	for(i=0, a=EEPROM_ADR; i<sizeof(S); i++, a++, p++){
		*p=EEPROM_read(a);
		if ( i<sizeof(S)-2) crc+=*p;
		}
	if (crc!=S.Crc) {
		EepromFlag=EEPROM_ERROR;
		S.LedLight=8;
		}
}
//-------------------------END-EEPROM---------------------------------------/
