#include "fan.h"

#include "bp.h"
#include "one_wire.h"

uint8_t FanState;
int16_t TimeSpinUp;

//---------------------COOLER---------------------------
void calculation_step_U(void){
uint8_t DeltaU;
int16_t DeltaT;
uint16_t StepU;
	DeltaU=S.Fan.UHi-S.Fan.ULow;
	DeltaT=S.Fan.THi-S.Fan.TLow;
	StepU= ((uint16_t)DeltaU*10) / DeltaT;
	S.Fan.Step=StepU;
}

static uint8_t calc_power_fan(void){
int16_t DeltaT;
uint8_t Power=S.Fan.UHi;
	
	if ( PinWireDS[T_VT] & Power1w )
	{
	if ( (Temperaturs[T_VT]) <= S.Fan.THi*10 )
		{
		DeltaT=(Temperaturs[T_VT]) - S.Fan.TLow*10;
		if ( DeltaT>0 )
			{
			Power= (DeltaT*S.Fan.Step)/100+S.Fan.ULow;
			}
		else
		if ( (DeltaT>=-5) && ((FanState & FAN_POWER_OFF)==0) ){
			Power=S.Fan.ULow;
			}
		else{
			if (S.Fan.OffTLo){
				Power=0;
				FanState|= FAN_POWER_OFF;
				}
				else
				Power=S.Fan.ULow;
			}
		}
	}
	return Power;
}

static void fan_power_off(void){
	FAN1_OFF;
}

static void fan_power_on(void){
	FAN1_ON;
}

uint8_t control_fan(uint8_t Manual_U){
uint8_t Power;
	
	if ( FanState & FAN_U_SETUP )
	{
	Power=Manual_U;
	fan_power_on();
	}
	else{
		
	if (Manual_U) 
		Power=Manual_U;
		else
		Power=calc_power_fan();
	
	if ( Power )//   
		{
		fan_power_on();// 
		if ( FanState & FAN_POWER_OFF)//   
			{
			FanState|= FAN_EVENT_POWER_ON; 	//   
			FanState&= ~FAN_POWER_OFF; //   
			TimeSpinUp=S.Fan.TimSpinUp*TimReg(0.5);//  
			}
		if ( FanState & FAN_EVENT_POWER_ON )//       U 
			{
			Power=S.Fan.USpinUp;
			}
		}
		else//    
		{
		if ( FanState & FAN_POWER_OFF){
			fan_power_off();
			}
		}
	}
	return Power;
}

void pwm_power_setup(uint8_t U){
	FanState|=FAN_U_SETUP;
	FAN1_OCR=control_fan(U);
}
//-------------------------------------------------------------------------------------------------------
