//#define TEST_PIN		B,0,H
//#define	TEST_PIN_SIGN	{ON(TEST_PIN);OFF(TEST_PIN);}


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms 262.14ms/F_CPU in MHz; _delay_us 768us/F_CPU in MHz */

#include "pin_macros.h"
#include "one_wire.h"


uint8_t Power1w;
const uint8_t PinWireDS[KOLVO_DS]={PWIRE_0,PWIRE_1};

static uint8_t ReadByteT1w[KOLVO_DS*2], ds18B20;
int16_t Temperaturs[KOLVO_DS];



//--------------- 1 Wire DALLAS -----------------

//***********************************************
static uint8_t readbit(void){

	cli();
		
	//DDR_1WIRE|=Power1w;//line down
	DDR_1WIRE|=PWIRE_0;
	DDR_1WIRE|=PWIRE_1;
	
	_delay_us(3);

	//DDR_1WIRE&=~PWIRES;//line up through 1.25us
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	
	_delay_us(11.5);

	uint8_t p;
	p=PIN_1WIRE;

	sei();
	_delay_us(47);
	
	return p;

}

//***********************************************
static void readbyte(uint8_t *data) {  
	//DDR_1WIRE&=~PWIRES;//line up
	//PORT_1WIRE&=~PWIRES;
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;


	for(uint8_t i=0, r=1; i<8; i++){//8bit
		uint8_t p;
		p=readbit();
	
		for(uint8_t j=0; j<KOLVO_DS; j++){//KOLVO_DS
			if ( p & PinWireDS[j] ) data[j*2]|=r;
			}
		r<<=1;
	}

	PORT_1WIRE|=Power1w;
	DDR_1WIRE|=Power1w;

}
//***********************************************
static void writebit0(void){
	cli();
	//PORT_1WIRE&=~PWIRES;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;
	DDR_1WIRE|=Power1w;//line down
	_delay_us(60);
	PORT_1WIRE|=Power1w;// line up 
	_delay_us(3);
	//DDR_1WIRE&=~PWIRES;//line up   
	//PORT_1WIRE&=~PWIRES;
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;
	sei();
}
//***********************************************
static void writebit1(void){
	cli();
	//PORT_1WIRE&=~PWIRES;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;
	DDR_1WIRE|=Power1w;//line down
	_delay_us(3);//new
	PORT_1WIRE|=Power1w;
	_delay_us(3);
	//DDR_1WIRE&=~PWIRES;//line up 
	//PORT_1WIRE&=~PWIRES;
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;
	sei();
	_delay_us(57);
}
//***********************************************
static void writebyte(unsigned char byte){
unsigned char i;
	//DDR_1WIRE&=~PWIRES;//line up
	//PORT_1WIRE&=~PWIRES;
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;
	
	for(i=0; i<8; i++){
		if (byte&_BV(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}

	PORT_1WIRE|=Power1w;
	DDR_1WIRE|=Power1w;

}
//****************************************

static void detectPresence(void){
uint8_t pin, Out1wire;
	
	//DDR_1WIRE&=~PWIRES;//line up
	//PORT_1WIRE&=~PWIRES;
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	PORT_1WIRE&=~PWIRE_0;
	PORT_1WIRE&=~PWIRE_1;

	Out1wire=PWIRES;
	
	//DDR_1WIRE|=PWIRES;
	DDR_1WIRE|=PWIRE_0;
	DDR_1WIRE|=PWIRE_1;
	_delay_ms(0.48);
	
	cli();
	//DDR_1WIRE&=~PWIRES;
	DDR_1WIRE&=~PWIRE_0;
	DDR_1WIRE&=~PWIRE_1;
	
	_delay_us(60);
	pin=PIN_1WIRE;
	sei();
	
	for(uint8_t i=0; i<KOLVO_DS; i++)
		{
		if (pin & PinWireDS[i] ) {
			Out1wire&=~PinWireDS[i];
			}
		}
	
	_delay_ms(0.3);
	
	pin=PIN_1WIRE;
	
	for(uint8_t i=0; i<KOLVO_DS; i++)
		{
		if ( !( pin & PinWireDS[i]) ) {
			Out1wire&=~PinWireDS[i];
			}
		}
	
		
	Power1w = Out1wire;

	PORT_1WIRE|=Power1w;
	DDR_1WIRE|=Power1w;
	
}

//****************************************
static void define_ds(void){
	ds18B20=0x00;
	detectPresence();
	writebyte(0x33);//READ ROM [33h]
	readbyte(ReadByteT1w);
	for(uint8_t i=0; i<KOLVO_DS; i++){
		if (ReadByteT1w[i*2]==0x28) ds18B20|=PinWireDS[i];
		}
}
//****************************************
void ds18b20_init(void){//scratchpad_save
	
	define_ds();
		
	detectPresence();//  
	Power1w&=ds18B20;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
	writebyte(0);//	TH
	writebyte(0);//	TL
	writebyte(0x7F);//	Statys 12bit
		
		/*detectPresence();//   EEPROM
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x48);//COPY SCRATCHPAD [48h]
		PORT_1WIRE=Power1w;
		DDR_1WIRE=Power1w;*/
}

	
//*******************************************
uint8_t izmerenie_t(void){
static uint8_t State1w;
static uint16_t Time1w;
uint8_t rezult=0;

	switch (State1w)
	{
	case(0)://
		State1w++;
		detectPresence();//  
		break;

	case(1):
//TEST_PIN_SIGN;		
		State1w++;//1.2ms
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		//Time1w=1000;//1.5sek
		Time1w=100;//1.7sek
//TEST_PIN_SIGN;
		break;

	case(2):
		if (--Time1w==0) State1w++;
		break;

	case(3):// e
		State1w++;
		detectPresence();//
		break;

	case(4):
		State1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		break;

	case(5):
		State1w++;
		readbyte(ReadByteT1w);//  lsb
		break;

	case(6):
		State1w++;
		readbyte(ReadByteT1w+1);//  msb
		break;

	case(7):
		State1w++;
		int16_t *p=(int16_t *)ReadByteT1w;

		for( uint8_t i=0; i<KOLVO_DS; i++){
			if ( ds18B20 & PinWireDS[i] )
				{
				int16_t T;
				T=((int16_t)(*p))*5/8;
				if (T!=850) Temperaturs[i]=T;//    :-)  ,   85 . !
				}
				else
				Temperaturs[i]=((int16_t)(*p))*5;
			p++;
			if (( PinWireDS[i] & Power1w )==0) Temperaturs[i]=0;
			}
		
		for(uint8_t i=0; i<sizeof(ReadByteT1w); i++) ReadByteT1w[i]=0;
		
		break;

	case(8):
		State1w=0;
		rezult=1;
		break;
	
	default:
		State1w=0;
		break;
	}
	
	return rezult;
}
//*******************************************
